#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

main(argc, argv)
int argc;
char **argv;
{

  int sockfd;
  struct sockaddr_in cli_addr, srv_addr;
  extern int errno;
  fd_set rfd;
  unsigned char buf[4096];
  int i, r, w;

  if (argc != 3) {
    fprintf(stderr, "usage tcon host port\n");
    exit (1);
  }

  bzero(&srv_addr, sizeof srv_addr);
  srv_addr.sin_family = AF_INET;
  srv_addr.sin_addr.s_addr = inet_addr (argv[1]);
  srv_addr.sin_port = htons(atoi(argv[2]));

  if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
    fprintf(stderr, "socket(): %s\n", strerror(errno));
    exit (1);
  }

  if (connect(sockfd, (struct sockaddr*)&srv_addr, sizeof (srv_addr)) < 0) {
    fprintf(stderr, "connect(): %s\n", strerror(errno));
    exit (1);
  }

  /* write data from socket to stdout */

  while (1) {

    FD_ZERO (&rfd);
    FD_SET (sockfd, &rfd);

    if (select (sockfd+1, &rfd, (fd_set *)0, (fd_set *)0, (struct timeval*)0)
      < 0)  {
      fprintf(stderr, "select(): %s\n", strerror(errno));
      exit (1);
    }

    if ((r = read(sockfd, &buf, sizeof buf)) < 0) {
      fprintf(stderr, "read(): %d bytes: %s\n", r, strerror(errno));
      exit (1);
    }

    if (!r) {
      fprintf(stderr, "EOF\n");
      exit (0);
    }
  
    if ((w = writen(1, &buf, r)) < 0) {
      fprintf(stderr, "write(): %s\n", strerror(errno));
      exit (1);
    }

  } /* while */
} /* main */

int writen(fd, ptr, nbytes)
register int fd;
register char *ptr; 
register int nbytes;
{
  
  int nleft, nwritten;

  nleft = nbytes;
  while (nleft > 0) {
    nwritten = write(fd, ptr, nleft);
    if (nwritten <= 0)
      return(nwritten); /* error */

    nleft -= nwritten;
    ptr += nwritten;
  }
  return(nbytes - nleft);
} /* writen */


